#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#include "boolean.h"
#include "readField.h"
#include "materiePrime.h"

Boolean leggiMateriaPrima(FILE *f, MateriaPrima *mp)
{
	Boolean ok;
	ok = fscanf(f, "%d ", &mp->codice) == 1;
	ok = ok && readField(f, mp->nome, ':') == ':';
	ok = ok && fscanf(f, "%f", &mp->prezzo) == 1;
	if (ok)
		fgetc(f);	//Mangia eventuale fine linea
	return ok;
}

MateriaPrima* leggiMateriePrime(char fileName[], int *dim)
{
	int i;
	MateriaPrima *result;
	FILE *f = fopen(fileName, "r");
	if (f == NULL)
		abort();

	fscanf(f, "%d\n", dim);
	result = (MateriaPrima*)malloc(sizeof(MateriaPrima) * (*dim));
	for (i = 0; i < *dim; i++)
	{
		if (!leggiMateriaPrima(f, result + i))
		{
			break;
		}
	}
	return result;
}

void printAllMateriePrime(MateriaPrima mp[], int dim)
{
	int i;
	for (i = 0; i < dim; i++)
	{
		printf("%d -- %s -- E%.2f\n", mp[i].codice, mp[i].nome, mp[i].prezzo);
	}
}

int compareElement(ELEMENT e1, ELEMENT e2)
{
	return e1.codice - e2.codice;
}

void sort(ELEMENT_ARRAY a, int dim) 
{
    int i, j;
    ELEMENT tmp;

    for (i = 1; i < dim; i++) 
    {
        tmp = a[i];
        for (j = i - 1; j >= 0 && compareElement(a[j], tmp) > 0; j--)
            a[j + 1] = a[j];
        a[j + 1] = tmp;
    }
}

int findElement(ELEMENT_ARRAY a, int dim, ELEMENT toSearch)
{
    int midPos = dim/2;
    if (compareElement(a[midPos], toSearch) == 0)
        return midPos;
    if (midPos == 0)
        return INT_MIN;
    if (compareElement(a[midPos], toSearch) > 0)
    {
        return findElement(a, midPos, toSearch);
    }
    else
    {
        int startPos = midPos+1;
        return startPos + findElement(&a[startPos],
			dim-startPos, toSearch);
    }
}

